package xyz.apiote.bimba.czwek.api

import xyz.apiote.fruchtfleisch.Reader
import java.io.InputStream

class UnknownResponseVersion(resource: String, version: ULong) :
	Exception("Unknown resource $resource in version $version")

interface LineResponse {
	companion object {
		fun unmarshal(stream: InputStream): LineResponse {
			val reader = Reader(stream)
			return when (val v = reader.readUInt().toULong()) {
				0UL -> LineResponseDev.unmarshal(stream)
				1UL -> LineResponseV1.unmarshal(stream)
				else -> throw UnknownResponseVersion("Line", v)
			}
		}
	}
}

data class LineResponseDev(
	val line: LineV2
) : LineResponse {
	companion object {
		fun unmarshal(stream: InputStream): LineResponseDev {
			return LineResponseDev(LineV2.unmarshal(stream))
		}
	}
}

data class LineResponseV1(
	val line: LineV1
) : LineResponse {
	companion object {
		fun unmarshal(stream: InputStream): LineResponseV1 {
			return LineResponseV1(LineV1.unmarshal(stream))
		}
	}
}

interface DeparturesResponse {
	companion object {
		fun unmarshal(stream: InputStream): DeparturesResponse {
			val reader = Reader(stream)
			return when (val v = reader.readUInt().toULong()) {
				0UL -> DeparturesResponseDev.unmarshal(stream)
				1UL -> DeparturesResponseV1.unmarshal(stream)
				2UL -> DeparturesResponseV2.unmarshal(stream)
				else -> throw UnknownResponseVersion("Departures", v)
			}
		}
	}
}

data class DeparturesResponseDev(
	val alerts: List<AlertV1>,
	val departures: List<DepartureV3>,
	val stop: StopV2
) : DeparturesResponse {
	companion object {
		fun unmarshal(stream: InputStream): DeparturesResponseDev {
			val alerts = mutableListOf<AlertV1>()
			val departures = mutableListOf<DepartureV3>()

			val reader = Reader(stream)
			val alertsNum = reader.readUInt().toULong()
			for (i in 0UL until alertsNum) {
				val alert = AlertV1.unmarshal(stream)
				alerts.add(alert)
			}
			val departuresNum = reader.readUInt().toULong()
			for (i in 0UL until departuresNum) {
				val departure = DepartureV3.unmarshal(stream)
				departures.add(departure)
			}

			return DeparturesResponseDev(alerts, departures, StopV2.unmarshal(stream))
		}
	}
}

data class DeparturesResponseV1(
	val alerts: List<AlertV1>,
	val departures: List<DepartureV1>,
	val stop: StopV1
) : DeparturesResponse {
	companion object {
		fun unmarshal(stream: InputStream): DeparturesResponseV1 {
			val alerts = mutableListOf<AlertV1>()
			val departures = mutableListOf<DepartureV1>()

			val reader = Reader(stream)
			val alertsNum = reader.readUInt().toULong()
			for (i in 0UL until alertsNum) {
				val alert = AlertV1.unmarshal(stream)
				alerts.add(alert)
			}
			val departuresNum = reader.readUInt().toULong()
			for (i in 0UL until departuresNum) {
				val departure = DepartureV1.unmarshal(stream)
				departures.add(departure)
			}

			return DeparturesResponseV1(alerts, departures, StopV1.unmarshal(stream))
		}
	}
}

data class DeparturesResponseV2(
	val alerts: List<AlertV1>,
	val departures: List<DepartureV2>,
	val stop: StopV2
) : DeparturesResponse {
	companion object {
		fun unmarshal(stream: InputStream): DeparturesResponseV2 {
			val alerts = mutableListOf<AlertV1>()
			val departures = mutableListOf<DepartureV2>()

			val reader = Reader(stream)
			val alertsNum = reader.readUInt().toULong()
			for (i in 0UL until alertsNum) {
				val alert = AlertV1.unmarshal(stream)
				alerts.add(alert)
			}
			val departuresNum = reader.readUInt().toULong()
			for (i in 0UL until departuresNum) {
				val departure = DepartureV2.unmarshal(stream)
				departures.add(departure)
			}

			return DeparturesResponseV2(alerts, departures, StopV2.unmarshal(stream))
		}
	}
}

interface QueryablesResponse {
	companion object {
		fun unmarshal(stream: InputStream): QueryablesResponse {
			val reader = Reader(stream)
			return when (val v = reader.readUInt().toULong()) {
				0UL -> QueryablesResponseDev.unmarshal(stream)
				1UL -> QueryablesResponseV1.unmarshal(stream)
				2UL -> QueryablesResponseV2.unmarshal(stream)
				else -> throw UnknownResponseVersion("Queryables", v)
			}
		}
	}
}

data class QueryablesResponseDev(val queryables: List<QueryableV3>) : QueryablesResponse {
	companion object {
		fun unmarshal(stream: InputStream): QueryablesResponseDev {
			val queryables = mutableListOf<QueryableV3>()
			val reader = Reader(stream)
			val n = reader.readUInt().toULong()
			for (i in 0UL until n) {
				when (val r = reader.readUInt().toULong()) {
					0UL -> {
						queryables.add(StopV2.unmarshal(stream))
					}

					1UL -> {
						queryables.add(LineV2.unmarshal(stream))
					}

					else -> {
						throw UnknownResourceVersionException("Queryable/$r", 0u)
					}
				}
			}
			return QueryablesResponseDev(queryables)
		}
	}
}

data class QueryablesResponseV1(val queryables: List<QueryableV1>) : QueryablesResponse {
	companion object {
		fun unmarshal(stream: InputStream): QueryablesResponseV1 {
			val queryables = mutableListOf<QueryableV1>()
			val reader = Reader(stream)
			val n = reader.readUInt().toULong()
			for (i in 0UL until n) {
				when (val r = reader.readUInt().toULong()) {
					0UL -> {
						queryables.add(StopV1.unmarshal(stream))
					}

					else -> {
						throw UnknownResourceVersionException("Queryable/$r", 1u)
					}
				}
			}
			return QueryablesResponseV1(queryables)
		}
	}
}

data class QueryablesResponseV2(val queryables: List<QueryableV2>) : QueryablesResponse {
	companion object {
		fun unmarshal(stream: InputStream): QueryablesResponseV2 {
			val queryables = mutableListOf<QueryableV2>()
			val reader = Reader(stream)
			val n = reader.readUInt().toULong()
			for (i in 0UL until n) {
				when (val r = reader.readUInt().toULong()) {
					0UL -> {
						queryables.add(StopV2.unmarshal(stream))
					}

					1UL -> {
						queryables.add(LineV1.unmarshal(stream))
					}

					else -> {
						throw UnknownResourceVersionException("Queryable/$r", 2u)
					}
				}
			}
			return QueryablesResponseV2(queryables)
		}
	}
}

interface FeedsResponse {
	companion object {
		fun unmarshal(stream: InputStream): FeedsResponse {
			val reader = Reader(stream)
			return when (val v = reader.readUInt().toULong()) {
				0UL -> FeedsResponseDev.unmarshal(stream)
				1UL -> FeedsResponseV1.unmarshal(stream)
				else -> throw UnknownResponseVersion("Feeds", v)
			}
		}
	}
}

data class FeedsResponseDev(
	val feeds: List<FeedInfoV1>
) : FeedsResponse {
	companion object {
		fun unmarshal(stream: InputStream): FeedsResponseDev {
			val feeds = mutableListOf<FeedInfoV1>()
			val reader = Reader(stream)
			val n = reader.readUInt().toULong()
			for (i in 0UL until n) {
				feeds.add(FeedInfoV1.unmarshal(stream))
			}
			return FeedsResponseDev(feeds)
		}
	}
}

data class FeedsResponseV1(
	val feeds: List<FeedInfoV1>
) : FeedsResponse {
	companion object {
		fun unmarshal(stream: InputStream): FeedsResponseV1 {
			val feeds = mutableListOf<FeedInfoV1>()
			val reader = Reader(stream)
			val n = reader.readUInt().toULong()
			for (i in 0UL until n) {
				feeds.add(FeedInfoV1.unmarshal(stream))
			}
			return FeedsResponseV1(feeds)
		}
	}
}

interface LocatablesResponse {
	companion object {
		fun unmarshal(stream: InputStream): LocatablesResponse {
			val reader = Reader(stream)
			return when (val v = reader.readUInt().toULong()) {
				0UL -> LocatablesResponseDev.unmarshal(stream)
				1UL -> LocatablesResponseV1.unmarshal(stream)
				2UL -> LocatablesResponseV2.unmarshal(stream)
				else -> throw UnknownResponseVersion("Locatables", v)
			}
		}
	}
}

data class LocatablesResponseDev(val locatables: List<LocatableV3>) : LocatablesResponse {
	companion object {
		fun unmarshal(stream: InputStream): LocatablesResponseDev {
			val locatables = mutableListOf<LocatableV3>()
			val reader = Reader(stream)
			val n = reader.readUInt().toULong()
			for (i in 0UL until n) {
				when (val r = reader.readUInt().toULong()) {
					0UL -> {
						locatables.add(StopV2.unmarshal(stream))
					}

					1UL -> {
						locatables.add(VehicleV3.unmarshal(stream))
					}

					else -> {
						throw UnknownResourceVersionException("Locatable/$r", 0u)
					}
				}
			}
			return LocatablesResponseDev(locatables)
		}
	}
}

data class LocatablesResponseV1(val locatables: List<LocatableV1>) : LocatablesResponse {
	companion object {
		fun unmarshal(stream: InputStream): LocatablesResponseV1 {
			val locatables = mutableListOf<LocatableV1>()
			val reader = Reader(stream)
			val n = reader.readUInt().toULong()
			for (i in 0UL until n) {
				when (val r = reader.readUInt().toULong()) {
					0UL -> {
						locatables.add(StopV1.unmarshal(stream))
					}

					1UL -> {
						locatables.add(VehicleV1.unmarshal(stream))
					}

					else -> {
						throw UnknownResourceVersionException("Locatable/$r", 1u)
					}
				}
			}
			return LocatablesResponseV1(locatables)
		}
	}
}

data class LocatablesResponseV2(val locatables: List<LocatableV2>) : LocatablesResponse {
	companion object {
		fun unmarshal(stream: InputStream): LocatablesResponseV2 {
			val locatables = mutableListOf<LocatableV2>()
			val reader = Reader(stream)
			val n = reader.readUInt().toULong()
			for (i in 0UL until n) {
				when (val r = reader.readUInt().toULong()) {
					0UL -> locatables.add(StopV2.unmarshal(stream))
					1UL -> locatables.add(VehicleV2.unmarshal(stream))
					else -> throw UnknownResourceVersionException("Locatable/$r", 2u)
				}
			}
			return LocatablesResponseV2(locatables)
		}
	}
}

data class ErrorResponse(val field: String, val message: String) {
	companion object {
		fun unmarshal(stream: InputStream): ErrorResponse {
			val reader = Reader(stream)
			return ErrorResponse(reader.readString(), reader.readString())
		}
	}
}